import{S as gu,i as _u,s as vu,e as n,k as r,w as h,t as p,M as bu,c as a,d as o,m as l,a as i,x as u,h as c,b as s,N as $,f as mu,G as e,g as d,y as g,q as _,o as v,B as b,v as wu,L as uu}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as J}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as A}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as R}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as hu}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function yu(mo){let k,j,C,y,x;return y=new A({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){k=n("p"),j=p("Examples:"),C=r(),h(y.$$.fragment)},l(m){k=a(m,"P",{});var N=i(k);j=c(N,"Examples:"),N.forEach(o),C=l(m),u(y.$$.fragment,m)},m(m,N){d(m,k,N),e(k,j),d(m,C,N),g(y,m,N),x=!0},p:uu,i(m){x||(_(y.$$.fragment,m),x=!0)},o(m){v(y.$$.fragment,m),x=!1},d(m){m&&o(k),m&&o(C),b(y,m)}}}function Eu(mo){let k,j,C,y,x;return y=new A({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){k=n("p"),j=p("Examples:"),C=r(),h(y.$$.fragment)},l(m){k=a(m,"P",{});var N=i(k);j=c(N,"Examples:"),N.forEach(o),C=l(m),u(y.$$.fragment,m)},m(m,N){d(m,k,N),e(k,j),d(m,C,N),g(y,m,N),x=!0},p:uu,i(m){x||(_(y.$$.fragment,m),x=!0)},o(m){v(y.$$.fragment,m),x=!1},d(m){m&&o(k),m&&o(C),b(y,m)}}}function $u(mo){let k,j,C,y,x,m,N,jn,ur,Pi,Q,fe,An,at,gr,In,_r,Ni,it,st,vr,br,Di,ho,wr,xi,uo,yr,Ti,go,Mn,Er,Si,de,$r,rt,kr,Cr,ji,_o,Pr,Ai,me,Ln,lt,Nr,Dr,qn,pt,xr,Ii,X,he,On,ct,Tr,Gn,Sr,Mi,ue,Un,ee,zn,jr,Ar,Fn,Ir,Mr,vo,Lr,qr,Rn,te,Hn,ft,Or,Gr,Wn,Vn,Ur,zr,bo,dt,Fr,Li,oe,ge,Bn,mt,Rr,Kn,Hr,qi,_e,Wr,Yn,Vr,Br,Oi,ve,Zn,Jn,Qn,Kr,Yr,Xn,wo,ht,Zr,yo,Jr,Qr,Gi,be,Xr,ut,el,tl,Ui,gt,zi,Eo,$o,Of,Fi,H,ol,ea,nl,al,ko,il,sl,Ri,Co,rl,Hi,_t,Wi,Po,ll,Vi,vt,Bi,No,pl,Ki,bt,Yi,Do,cl,Zi,xo,To,Gf,Ji,we,fl,So,dl,ml,Qi,wt,Xi,ye,hl,jo,ul,gl,es,yt,ts,Ao,_l,os,Et,ns,Io,vl,as,Mo,Lo,Uf,is,Ee,ta,bl,wl,qo,yl,ss,ne,$e,oa,$t,El,na,$l,rs,ke,kl,aa,Cl,Pl,ls,Oo,Nl,ps,Ce,Dl,ia,xl,Tl,cs,ae,Pe,sa,kt,Sl,ra,jl,fs,Go,Al,ds,Uo,zf,ms,zo,Il,hs,Ct,us,Fo,Ff,gs,ie,Ne,la,Pt,Ml,pa,Ll,_s,Ro,ql,vs,Nt,Rf,bs,Ho,Ol,ws,Dt,ys,xt,Hf,Es,se,De,ca,Tt,Gl,fa,Ul,$s,St,ks,jt,Wf,Cs,re,xe,da,At,zl,ma,Fl,Ps,W,Rl,ha,Hl,Wl,ua,Vl,Bl,Ns,Te,Kl,It,Yl,Zl,Ds,le,Se,ga,Mt,Jl,_a,Ql,xs,je,va,I,ba,Xl,ep,wa,tp,op,ya,np,ap,Ea,ip,sp,P,M,Ae,Lt,rp,lp,pp,$a,cp,fp,ka,dp,mp,Ca,Wo,Ie,Vf,hp,Pa,Vo,Bo,Bf,up,L,Me,qt,gp,_p,vp,Na,bp,wp,Da,yp,Ep,xa,Ko,Yo,Kf,$p,Ta,Zo,Jo,Yf,kp,q,Le,Ot,Cp,Pp,Np,Sa,Dp,xp,ja,Tp,Sp,Aa,Qo,Xo,Zf,jp,Ia,en,tn,Jf,Ap,O,qe,Gt,Ip,Mp,Lp,Ma,qp,Op,La,Gp,Up,qa,on,nn,Qf,zp,Oa,an,sn,Xf,Fp,G,Oe,Ut,Rp,Hp,Wp,Ga,Vp,Bp,zt,Kp,Ft,Yp,Zp,Jp,Ua,rn,ln,ed,Qp,za,pn,cn,td,Xp,U,Ge,Rt,ec,tc,oc,Fa,nc,ac,Ht,ic,Wt,sc,rc,lc,Ra,fn,dn,od,pc,Ha,mn,hn,nd,cc,z,Ue,Vt,fc,dc,mc,Wa,hc,uc,Va,gc,_c,Ba,un,gn,ad,vc,Ka,_n,vn,id,bc,F,Bt,Kt,wc,yc,Ya,Ec,$c,Yt,kc,Zt,Cc,Pc,Nc,Za,bn,wn,sd,Dc,Ja,yn,En,rd,Ts,pe,ze,Qa,Jt,xc,Xa,Tc,Ss,w,Qt,Sc,ei,jc,Ac,Xt,Ic,$n,Mc,Lc,qc,V,eo,Oc,ti,Gc,Uc,Fe,zc,B,to,Fc,oi,Rc,Hc,ni,Wc,Vc,Re,oo,Bc,no,Kc,ai,Yc,Zc,Jc,K,ao,Qc,ii,Xc,ef,si,tf,of,He,io,nf,so,af,ri,sf,rf,lf,T,ro,pf,li,cf,ff,pi,df,mf,ci,hf,uf,We,gf,Ve,lo,_f,fi,vf,bf,Be,po,wf,S,yf,di,Ef,$f,mi,kf,Cf,hi,Pf,Nf,ui,Df,xf,Tf,Ke,co,Sf,ce,jf,gi,Af,If,_i,Mf,Lf,js;return m=new R({}),at=new R({}),ct=new R({}),mt=new R({}),gt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),_t=new A({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),vt=new A({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),bt=new A({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),wt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),yt=new A({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),Et=new A({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),$t=new R({}),kt=new R({}),Ct=new A({props:{code:`from diffusers.utils import load_image
from PIL import Image
import cv2
import numpy as np
from diffusers.utils import load_image

canny_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png"
)
canny_image = np.array(canny_image)

low_threshold = 100
high_threshold = 200

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

# zero out middle columns of image where pose will be overlayed
zero_start = canny_image.shape[1] // 4
zero_end = zero_start + canny_image.shape[1] // 2
canny_image[:, zero_start:zero_end] = 0

canny_image = canny_image[:, :, None]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=2)
canny_image = Image.fromarray(canny_image)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

canny_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png&quot;</span>
)
canny_image = np.array(canny_image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

<span class="hljs-comment"># zero out middle columns of image where pose will be overlayed</span>
zero_start = canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">4</span>
zero_end = zero_start + canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">2</span>
canny_image[:, zero_start:zero_end] = <span class="hljs-number">0</span>

canny_image = canny_image[:, :, <span class="hljs-literal">None</span>]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(canny_image)`}}),Pt=new R({}),Dt=new A({props:{code:`from controlnet_aux import OpenposeDetector
from diffusers.utils import load_image

openpose = OpenposeDetector.from_pretrained("lllyasviel/ControlNet")

openpose_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png"
)
openpose_image = openpose(openpose_image)`,highlighted:`<span class="hljs-keyword">from</span> controlnet_aux <span class="hljs-keyword">import</span> OpenposeDetector
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

openpose = OpenposeDetector.from_pretrained(<span class="hljs-string">&quot;lllyasviel/ControlNet&quot;</span>)

openpose_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png&quot;</span>
)
openpose_image = openpose(openpose_image)`}}),Tt=new R({}),St=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
import torch

controlnet = [
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-openpose", torch_dtype=torch.float16),
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = "a giant standing in a fantasy landscape, best quality"
negative_prompt = "monochrome, lowres, bad anatomy, worst quality, low quality"

generator = torch.Generator(device="cpu").manual_seed(1)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=20,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[1.0, 0.8],
).images[0]

image.save("./multi_controlnet_output.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-keyword">import</span> torch

controlnet = [
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-openpose&quot;</span>, torch_dtype=torch.float16),
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;a giant standing in a fantasy landscape, best quality&quot;</span>
negative_prompt = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

generator = torch.Generator(device=<span class="hljs-string">&quot;cpu&quot;</span>).manual_seed(<span class="hljs-number">1</span>)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=<span class="hljs-number">20</span>,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[<span class="hljs-number">1.0</span>, <span class="hljs-number">0.8</span>],
).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;./multi_controlnet_output.png&quot;</span>)`}}),At=new R({}),Mt=new R({}),Jt=new R({}),Qt=new J({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": typing.Union[diffusers.models.controlnet.ControlNetModel, typing.List[diffusers.models.controlnet.ControlNetModel], typing.Tuple[diffusers.models.controlnet.ControlNetModel], diffusers.pipelines.stable_diffusion.pipeline_stable_diffusion_controlnet.MultiControlNetModel]"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2759/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2759/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2759/en/api/models#diffusers.ControlNetModel">ControlNetModel</a> or <code>List[ControlNetModel]</code>) &#x2014;
Provides additional conditioning to the unet during the denoising process. If you set multiple ControlNets
as a list, the outputs from each ControlNet are added together to create one combined additional
conditioning.`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2759/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2759/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2759/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2759/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L149"}}),eo=new J({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, typing.List[float]] = 1.0"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code>, <code>List[PIL.Image.Image]</code>, &#x2014;
<code>List[List[torch.FloatTensor]]</code>, or <code>List[List[PIL.Image.Image]]</code>):
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. <code>PIL.Image.Image</code> can
also be accepted as an image. The dimensions of the output image defaults to <code>image</code>&#x2019;s dimensions. If
height and/or width are passed, <code>image</code> is resized according to them. If multiple ControlNets are
specified in init, images must be passed as a list such that each element of the list can be correctly
batched for input to a single controlnet.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. If not defined, one has to pass <code>negative_prompt_embeds</code>. instead.
Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2759/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2759/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet. If multiple ControlNets are specified in init, you can set the
corresponding scale as a list.`,name:"controlnet_conditioning_scale"}],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L704",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2759/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2759/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),Fe=new hu({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[yu]},$$scope:{ctx:mo}}}),to=new J({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/pipeline_utils.py#L1354"}}),oo=new J({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/pipeline_utils.py#L1370"}}),ao=new J({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L229"}}),io=new J({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L239"}}),ro=new J({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/pipeline_utils.py#L1297"}}),We=new hu({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Eu]},$$scope:{ctx:mo}}}),lo=new J({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/pipeline_utils.py#L1329"}}),po=new J({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L267"}}),co=new J({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2759/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L246"}}),{c(){k=n("meta"),j=r(),C=n("h1"),y=n("a"),x=n("span"),h(m.$$.fragment),N=r(),jn=n("span"),ur=p("Text-to-Image Generation with ControlNet Conditioning"),Pi=r(),Q=n("h2"),fe=n("a"),An=n("span"),h(at.$$.fragment),gr=r(),In=n("span"),_r=p("Overview"),Ni=r(),it=n("p"),st=n("a"),vr=p("Adding Conditional Control to Text-to-Image Diffusion Models"),br=p(" by Lvmin Zhang and Maneesh Agrawala."),Di=r(),ho=n("p"),wr=p("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),xi=r(),uo=n("p"),yr=p("The abstract of the paper is the following:"),Ti=r(),go=n("p"),Mn=n("em"),Er=p("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Si=r(),de=n("p"),$r=p("This model was contributed by the amazing community contributor "),rt=n("a"),kr=p("takuma104"),Cr=p(" \u2764\uFE0F ."),ji=r(),_o=n("p"),Pr=p("Resources:"),Ai=r(),me=n("ul"),Ln=n("li"),lt=n("a"),Nr=p("Paper"),Dr=r(),qn=n("li"),pt=n("a"),xr=p("Original Code"),Ii=r(),X=n("h2"),he=n("a"),On=n("span"),h(ct.$$.fragment),Tr=r(),Gn=n("span"),Sr=p("Available Pipelines:"),Mi=r(),ue=n("table"),Un=n("thead"),ee=n("tr"),zn=n("th"),jr=p("Pipeline"),Ar=r(),Fn=n("th"),Ir=p("Tasks"),Mr=r(),vo=n("th"),Lr=p("Demo"),qr=r(),Rn=n("tbody"),te=n("tr"),Hn=n("td"),ft=n("a"),Or=p("StableDiffusionControlNetPipeline"),Gr=r(),Wn=n("td"),Vn=n("em"),Ur=p("Text-to-Image Generation with ControlNet Conditioning"),zr=r(),bo=n("td"),dt=n("a"),Fr=p("Colab Example"),Li=r(),oe=n("h2"),ge=n("a"),Bn=n("span"),h(mt.$$.fragment),Rr=r(),Kn=n("span"),Hr=p("Usage example"),qi=r(),_e=n("p"),Wr=p("In the following we give a simple example of how to use a "),Yn=n("em"),Vr=p("ControlNet"),Br=p(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Oi=r(),ve=n("ul"),Zn=n("li"),Jn=n("ol"),Qn=n("li"),Kr=p("Take an image and run it through a pre-conditioning processor."),Yr=r(),Xn=n("li"),wo=n("ol"),ht=n("li"),Zr=p("Run the pre-processed image through the "),yo=n("a"),Jr=p("StableDiffusionControlNetPipeline"),Qr=p("."),Gi=r(),be=n("p"),Xr=p("Let\u2019s have a look at a simple example using the "),ut=n("a"),el=p("Canny Edge ControlNet"),tl=p("."),Ui=r(),h(gt.$$.fragment),zi=r(),Eo=n("p"),$o=n("img"),Fi=r(),H=n("p"),ol=p("Next, we process the image to get the canny image. This is step "),ea=n("em"),nl=p("1."),al=p(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),ko=n("a"),il=p("official checkpoints"),sl=p(" for more information about other models."),Ri=r(),Co=n("p"),rl=p("First, we need to install opencv:"),Hi=r(),h(_t.$$.fragment),Wi=r(),Po=n("p"),ll=p("Next, let\u2019s also install all required Hugging Face libraries:"),Vi=r(),h(vt.$$.fragment),Bi=r(),No=n("p"),pl=p("Then we can retrieve the canny edges of the image."),Ki=r(),h(bt.$$.fragment),Yi=r(),Do=n("p"),cl=p("Let\u2019s take a look at the processed image."),Zi=r(),xo=n("p"),To=n("img"),Ji=r(),we=n("p"),fl=p("Now, we load the official "),So=n("a"),dl=p("Stable Diffusion 1.5 Model"),ml=p(" as well as the ControlNet for canny edges."),Qi=r(),h(wt.$$.fragment),Xi=r(),ye=n("p"),hl=p("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),jo=n("a"),ul=p("UniPCMultistepScheduler"),gl=p("."),es=r(),h(yt.$$.fragment),ts=r(),Ao=n("p"),_l=p("Finally, we can run the pipeline:"),os=r(),h(Et.$$.fragment),ns=r(),Io=n("p"),vl=p("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),as=r(),Mo=n("p"),Lo=n("img"),is=r(),Ee=n("p"),ta=n("strong"),bl=p("Note"),wl=p(": To see how to run all other ControlNet checkpoints, please have a look at "),qo=n("a"),yl=p("ControlNet with Stable Diffusion 1.5"),ss=r(),ne=n("h2"),$e=n("a"),oa=n("span"),h($t.$$.fragment),El=r(),na=n("span"),$l=p("Combining multiple conditionings"),rs=r(),ke=n("p"),kl=p("Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),aa=n("code"),Cl=p("__call__"),Pl=p("."),ls=r(),Oo=n("p"),Nl=p("When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),ps=r(),Ce=n("p"),Dl=p("It can also be helpful to vary the "),ia=n("code"),xl=p("controlnet_conditioning_scales"),Tl=p(" to emphasize one conditioning over the other."),cs=r(),ae=n("h3"),Pe=n("a"),sa=n("span"),h(kt.$$.fragment),Sl=r(),ra=n("span"),jl=p("Canny conditioning"),fs=r(),Go=n("p"),Al=p("The original image:"),ds=r(),Uo=n("img"),ms=r(),zo=n("p"),Il=p("Prepare the conditioning:"),hs=r(),h(Ct.$$.fragment),us=r(),Fo=n("img"),gs=r(),ie=n("h3"),Ne=n("a"),la=n("span"),h(Pt.$$.fragment),Ml=r(),pa=n("span"),Ll=p("Openpose conditioning"),_s=r(),Ro=n("p"),ql=p("The original image:"),vs=r(),Nt=n("img"),bs=r(),Ho=n("p"),Ol=p("Prepare the conditioning:"),ws=r(),h(Dt.$$.fragment),ys=r(),xt=n("img"),Es=r(),se=n("h3"),De=n("a"),ca=n("span"),h(Tt.$$.fragment),Gl=r(),fa=n("span"),Ul=p("Running ControlNet with multiple conditionings"),$s=r(),h(St.$$.fragment),ks=r(),jt=n("img"),Cs=r(),re=n("h2"),xe=n("a"),da=n("span"),h(At.$$.fragment),zl=r(),ma=n("span"),Fl=p("Available checkpoints"),Ps=r(),W=n("p"),Rl=p("ControlNet requires a "),ha=n("em"),Hl=p("control image"),Wl=p(" in addition to the text-to-image "),ua=n("em"),Vl=p("prompt"),Bl=p(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Ns=r(),Te=n("p"),Kl=p("All checkpoints can be found under the authors\u2019 namespace "),It=n("a"),Yl=p("lllyasviel"),Zl=p("."),Ds=r(),le=n("h3"),Se=n("a"),ga=n("span"),h(Mt.$$.fragment),Jl=r(),_a=n("span"),Ql=p("ControlNet with Stable Diffusion 1.5"),xs=r(),je=n("table"),va=n("thead"),I=n("tr"),ba=n("th"),Xl=p("Model Name"),ep=r(),wa=n("th"),tp=p("Control Image Overview"),op=r(),ya=n("th"),np=p("Control Image Example"),ap=r(),Ea=n("th"),ip=p("Generated Image Example"),sp=r(),P=n("tbody"),M=n("tr"),Ae=n("td"),Lt=n("a"),rp=p("lllyasviel/sd-controlnet-canny"),lp=n("br"),pp=r(),$a=n("em"),cp=p("Trained with canny edge detection"),fp=r(),ka=n("td"),dp=p("A monochrome image with white edges on a black background."),mp=r(),Ca=n("td"),Wo=n("a"),Ie=n("img"),hp=r(),Pa=n("td"),Vo=n("a"),Bo=n("img"),up=r(),L=n("tr"),Me=n("td"),qt=n("a"),gp=p("lllyasviel/sd-controlnet-depth"),_p=n("br"),vp=r(),Na=n("em"),bp=p("Trained with Midas depth estimation"),wp=r(),Da=n("td"),yp=p("A grayscale image with black representing deep areas and white representing shallow areas."),Ep=r(),xa=n("td"),Ko=n("a"),Yo=n("img"),$p=r(),Ta=n("td"),Zo=n("a"),Jo=n("img"),kp=r(),q=n("tr"),Le=n("td"),Ot=n("a"),Cp=p("lllyasviel/sd-controlnet-hed"),Pp=n("br"),Np=r(),Sa=n("em"),Dp=p("Trained with HED edge detection (soft edge)"),xp=r(),ja=n("td"),Tp=p("A monochrome image with white soft edges on a black background."),Sp=r(),Aa=n("td"),Qo=n("a"),Xo=n("img"),jp=r(),Ia=n("td"),en=n("a"),tn=n("img"),Ap=r(),O=n("tr"),qe=n("td"),Gt=n("a"),Ip=p("lllyasviel/sd-controlnet-mlsd"),Mp=n("br"),Lp=r(),Ma=n("em"),qp=p("Trained with M-LSD line detection"),Op=r(),La=n("td"),Gp=p("A monochrome image composed only of white straight lines on a black background."),Up=r(),qa=n("td"),on=n("a"),nn=n("img"),zp=r(),Oa=n("td"),an=n("a"),sn=n("img"),Fp=r(),G=n("tr"),Oe=n("td"),Ut=n("a"),Rp=p("lllyasviel/sd-controlnet-normal"),Hp=n("br"),Wp=r(),Ga=n("em"),Vp=p("Trained with normal map"),Bp=r(),zt=n("td"),Kp=p("A "),Ft=n("a"),Yp=p("normal mapped"),Zp=p(" image."),Jp=r(),Ua=n("td"),rn=n("a"),ln=n("img"),Qp=r(),za=n("td"),pn=n("a"),cn=n("img"),Xp=r(),U=n("tr"),Ge=n("td"),Rt=n("a"),ec=p("lllyasviel/sd-controlnet-openpose"),tc=n("br"),oc=r(),Fa=n("em"),nc=p("Trained with OpenPose bone image"),ac=r(),Ht=n("td"),ic=p("A "),Wt=n("a"),sc=p("OpenPose bone"),rc=p(" image."),lc=r(),Ra=n("td"),fn=n("a"),dn=n("img"),pc=r(),Ha=n("td"),mn=n("a"),hn=n("img"),cc=r(),z=n("tr"),Ue=n("td"),Vt=n("a"),fc=p("lllyasviel/sd-controlnet-scribble"),dc=n("br"),mc=r(),Wa=n("em"),hc=p("Trained with human scribbles"),uc=r(),Va=n("td"),gc=p("A hand-drawn monochrome image with white outlines on a black background."),_c=r(),Ba=n("td"),un=n("a"),gn=n("img"),vc=r(),Ka=n("td"),_n=n("a"),vn=n("img"),bc=r(),F=n("tr"),Bt=n("td"),Kt=n("a"),wc=p("lllyasviel/sd-controlnet-seg"),yc=n("br"),Ya=n("em"),Ec=p("Trained with semantic segmentation"),$c=r(),Yt=n("td"),kc=p("An "),Zt=n("a"),Cc=p("ADE20K"),Pc=p("\u2019s segmentation protocol image."),Nc=r(),Za=n("td"),bn=n("a"),wn=n("img"),Dc=r(),Ja=n("td"),yn=n("a"),En=n("img"),Ts=r(),pe=n("h2"),ze=n("a"),Qa=n("span"),h(Jt.$$.fragment),xc=r(),Xa=n("span"),Tc=p("StableDiffusionControlNetPipeline"),Ss=r(),w=n("div"),h(Qt.$$.fragment),Sc=r(),ei=n("p"),jc=p("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Ac=r(),Xt=n("p"),Ic=p("This model inherits from "),$n=n("a"),Mc=p("DiffusionPipeline"),Lc=p(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),qc=r(),V=n("div"),h(eo.$$.fragment),Oc=r(),ti=n("p"),Gc=p("Function invoked when calling the pipeline for generation."),Uc=r(),h(Fe.$$.fragment),zc=r(),B=n("div"),h(to.$$.fragment),Fc=r(),oi=n("p"),Rc=p("Enable sliced attention computation."),Hc=r(),ni=n("p"),Wc=p(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Vc=r(),Re=n("div"),h(oo.$$.fragment),Bc=r(),no=n("p"),Kc=p("Disable sliced attention computation. If "),ai=n("code"),Yc=p("enable_attention_slicing"),Zc=p(` was previously invoked, this method will go
back to computing attention in one step.`),Jc=r(),K=n("div"),h(ao.$$.fragment),Qc=r(),ii=n("p"),Xc=p("Enable sliced VAE decoding."),ef=r(),si=n("p"),tf=p(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),of=r(),He=n("div"),h(io.$$.fragment),nf=r(),so=n("p"),af=p("Disable sliced VAE decoding. If "),ri=n("code"),sf=p("enable_vae_slicing"),rf=p(` was previously invoked, this method will go back to
computing decoding in one step.`),lf=r(),T=n("div"),h(ro.$$.fragment),pf=r(),li=n("p"),cf=p("Enable memory efficient attention as implemented in xformers."),ff=r(),pi=n("p"),df=p(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),mf=r(),ci=n("p"),hf=p(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),uf=r(),h(We.$$.fragment),gf=r(),Ve=n("div"),h(lo.$$.fragment),_f=r(),fi=n("p"),vf=p("Disable memory efficient attention as implemented in xformers."),bf=r(),Be=n("div"),h(po.$$.fragment),wf=r(),S=n("p"),yf=p(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),di=n("code"),Ef=p("enable_sequential_cpu_offload"),$f=p(", this method moves one whole model at a time to the GPU when its "),mi=n("code"),kf=p("forward"),Cf=p(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),hi=n("code"),Pf=p("enable_sequential_cpu_offload"),Nf=p(", but performance is much better due to the iterative execution of the "),ui=n("code"),Df=p("unet"),xf=p("."),Tf=r(),Ke=n("div"),h(co.$$.fragment),Sf=r(),ce=n("p"),jf=p(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),gi=n("code"),Af=p("torch.device('meta') and loaded to GPU only when their specific submodule has its "),If=p("forward"),_i=n("code"),Mf=p("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Lf=p("enable_model_cpu_offload`, but performance is lower."),this.h()},l(t){const f=bu('[data-svelte="svelte-1phssyn"]',document.head);k=a(f,"META",{name:!0,content:!0}),f.forEach(o),j=l(t),C=a(t,"H1",{class:!0});var fo=i(C);y=a(fo,"A",{id:!0,class:!0,href:!0});var vi=i(y);x=a(vi,"SPAN",{});var ld=i(x);u(m.$$.fragment,ld),ld.forEach(o),vi.forEach(o),N=l(fo),jn=a(fo,"SPAN",{});var pd=i(jn);ur=c(pd,"Text-to-Image Generation with ControlNet Conditioning"),pd.forEach(o),fo.forEach(o),Pi=l(t),Q=a(t,"H2",{class:!0});var As=i(Q);fe=a(As,"A",{id:!0,class:!0,href:!0});var cd=i(fe);An=a(cd,"SPAN",{});var fd=i(An);u(at.$$.fragment,fd),fd.forEach(o),cd.forEach(o),gr=l(As),In=a(As,"SPAN",{});var dd=i(In);_r=c(dd,"Overview"),dd.forEach(o),As.forEach(o),Ni=l(t),it=a(t,"P",{});var qf=i(it);st=a(qf,"A",{href:!0,rel:!0});var md=i(st);vr=c(md,"Adding Conditional Control to Text-to-Image Diffusion Models"),md.forEach(o),br=c(qf," by Lvmin Zhang and Maneesh Agrawala."),qf.forEach(o),Di=l(t),ho=a(t,"P",{});var hd=i(ho);wr=c(hd,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),hd.forEach(o),xi=l(t),uo=a(t,"P",{});var ud=i(uo);yr=c(ud,"The abstract of the paper is the following:"),ud.forEach(o),Ti=l(t),go=a(t,"P",{});var gd=i(go);Mn=a(gd,"EM",{});var _d=i(Mn);Er=c(_d,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),_d.forEach(o),gd.forEach(o),Si=l(t),de=a(t,"P",{});var Is=i(de);$r=c(Is,"This model was contributed by the amazing community contributor "),rt=a(Is,"A",{href:!0,rel:!0});var vd=i(rt);kr=c(vd,"takuma104"),vd.forEach(o),Cr=c(Is," \u2764\uFE0F ."),Is.forEach(o),ji=l(t),_o=a(t,"P",{});var bd=i(_o);Pr=c(bd,"Resources:"),bd.forEach(o),Ai=l(t),me=a(t,"UL",{});var Ms=i(me);Ln=a(Ms,"LI",{});var wd=i(Ln);lt=a(wd,"A",{href:!0,rel:!0});var yd=i(lt);Nr=c(yd,"Paper"),yd.forEach(o),wd.forEach(o),Dr=l(Ms),qn=a(Ms,"LI",{});var Ed=i(qn);pt=a(Ed,"A",{href:!0,rel:!0});var $d=i(pt);xr=c($d,"Original Code"),$d.forEach(o),Ed.forEach(o),Ms.forEach(o),Ii=l(t),X=a(t,"H2",{class:!0});var Ls=i(X);he=a(Ls,"A",{id:!0,class:!0,href:!0});var kd=i(he);On=a(kd,"SPAN",{});var Cd=i(On);u(ct.$$.fragment,Cd),Cd.forEach(o),kd.forEach(o),Tr=l(Ls),Gn=a(Ls,"SPAN",{});var Pd=i(Gn);Sr=c(Pd,"Available Pipelines:"),Pd.forEach(o),Ls.forEach(o),Mi=l(t),ue=a(t,"TABLE",{});var qs=i(ue);Un=a(qs,"THEAD",{});var Nd=i(Un);ee=a(Nd,"TR",{});var kn=i(ee);zn=a(kn,"TH",{});var Dd=i(zn);jr=c(Dd,"Pipeline"),Dd.forEach(o),Ar=l(kn),Fn=a(kn,"TH",{});var xd=i(Fn);Ir=c(xd,"Tasks"),xd.forEach(o),Mr=l(kn),vo=a(kn,"TH",{align:!0});var Td=i(vo);Lr=c(Td,"Demo"),Td.forEach(o),kn.forEach(o),Nd.forEach(o),qr=l(qs),Rn=a(qs,"TBODY",{});var Sd=i(Rn);te=a(Sd,"TR",{});var Cn=i(te);Hn=a(Cn,"TD",{});var jd=i(Hn);ft=a(jd,"A",{href:!0,rel:!0});var Ad=i(ft);Or=c(Ad,"StableDiffusionControlNetPipeline"),Ad.forEach(o),jd.forEach(o),Gr=l(Cn),Wn=a(Cn,"TD",{});var Id=i(Wn);Vn=a(Id,"EM",{});var Md=i(Vn);Ur=c(Md,"Text-to-Image Generation with ControlNet Conditioning"),Md.forEach(o),Id.forEach(o),zr=l(Cn),bo=a(Cn,"TD",{align:!0});var Ld=i(bo);dt=a(Ld,"A",{href:!0,rel:!0});var qd=i(dt);Fr=c(qd,"Colab Example"),qd.forEach(o),Ld.forEach(o),Cn.forEach(o),Sd.forEach(o),qs.forEach(o),Li=l(t),oe=a(t,"H2",{class:!0});var Os=i(oe);ge=a(Os,"A",{id:!0,class:!0,href:!0});var Od=i(ge);Bn=a(Od,"SPAN",{});var Gd=i(Bn);u(mt.$$.fragment,Gd),Gd.forEach(o),Od.forEach(o),Rr=l(Os),Kn=a(Os,"SPAN",{});var Ud=i(Kn);Hr=c(Ud,"Usage example"),Ud.forEach(o),Os.forEach(o),qi=l(t),_e=a(t,"P",{});var Gs=i(_e);Wr=c(Gs,"In the following we give a simple example of how to use a "),Yn=a(Gs,"EM",{});var zd=i(Yn);Vr=c(zd,"ControlNet"),zd.forEach(o),Br=c(Gs,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Gs.forEach(o),Oi=l(t),ve=a(t,"UL",{});var Us=i(ve);Zn=a(Us,"LI",{});var Fd=i(Zn);Jn=a(Fd,"OL",{});var Rd=i(Jn);Qn=a(Rd,"LI",{});var Hd=i(Qn);Kr=c(Hd,"Take an image and run it through a pre-conditioning processor."),Hd.forEach(o),Rd.forEach(o),Fd.forEach(o),Yr=l(Us),Xn=a(Us,"LI",{});var Wd=i(Xn);wo=a(Wd,"OL",{start:!0});var Vd=i(wo);ht=a(Vd,"LI",{});var zs=i(ht);Zr=c(zs,"Run the pre-processed image through the "),yo=a(zs,"A",{href:!0});var Bd=i(yo);Jr=c(Bd,"StableDiffusionControlNetPipeline"),Bd.forEach(o),Qr=c(zs,"."),zs.forEach(o),Vd.forEach(o),Wd.forEach(o),Us.forEach(o),Gi=l(t),be=a(t,"P",{});var Fs=i(be);Xr=c(Fs,"Let\u2019s have a look at a simple example using the "),ut=a(Fs,"A",{href:!0,rel:!0});var Kd=i(ut);el=c(Kd,"Canny Edge ControlNet"),Kd.forEach(o),tl=c(Fs,"."),Fs.forEach(o),Ui=l(t),u(gt.$$.fragment,t),zi=l(t),Eo=a(t,"P",{});var Yd=i(Eo);$o=a(Yd,"IMG",{src:!0,alt:!0}),Yd.forEach(o),Fi=l(t),H=a(t,"P",{});var Pn=i(H);ol=c(Pn,"Next, we process the image to get the canny image. This is step "),ea=a(Pn,"EM",{});var Zd=i(ea);nl=c(Zd,"1."),Zd.forEach(o),al=c(Pn," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),ko=a(Pn,"A",{href:!0});var Jd=i(ko);il=c(Jd,"official checkpoints"),Jd.forEach(o),sl=c(Pn," for more information about other models."),Pn.forEach(o),Ri=l(t),Co=a(t,"P",{});var Qd=i(Co);rl=c(Qd,"First, we need to install opencv:"),Qd.forEach(o),Hi=l(t),u(_t.$$.fragment,t),Wi=l(t),Po=a(t,"P",{});var Xd=i(Po);ll=c(Xd,"Next, let\u2019s also install all required Hugging Face libraries:"),Xd.forEach(o),Vi=l(t),u(vt.$$.fragment,t),Bi=l(t),No=a(t,"P",{});var em=i(No);pl=c(em,"Then we can retrieve the canny edges of the image."),em.forEach(o),Ki=l(t),u(bt.$$.fragment,t),Yi=l(t),Do=a(t,"P",{});var tm=i(Do);cl=c(tm,"Let\u2019s take a look at the processed image."),tm.forEach(o),Zi=l(t),xo=a(t,"P",{});var om=i(xo);To=a(om,"IMG",{src:!0,alt:!0}),om.forEach(o),Ji=l(t),we=a(t,"P",{});var Rs=i(we);fl=c(Rs,"Now, we load the official "),So=a(Rs,"A",{href:!0});var nm=i(So);dl=c(nm,"Stable Diffusion 1.5 Model"),nm.forEach(o),ml=c(Rs," as well as the ControlNet for canny edges."),Rs.forEach(o),Qi=l(t),u(wt.$$.fragment,t),Xi=l(t),ye=a(t,"P",{});var Hs=i(ye);hl=c(Hs,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),jo=a(Hs,"A",{href:!0});var am=i(jo);ul=c(am,"UniPCMultistepScheduler"),am.forEach(o),gl=c(Hs,"."),Hs.forEach(o),es=l(t),u(yt.$$.fragment,t),ts=l(t),Ao=a(t,"P",{});var im=i(Ao);_l=c(im,"Finally, we can run the pipeline:"),im.forEach(o),os=l(t),u(Et.$$.fragment,t),ns=l(t),Io=a(t,"P",{});var sm=i(Io);vl=c(sm,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),sm.forEach(o),as=l(t),Mo=a(t,"P",{});var rm=i(Mo);Lo=a(rm,"IMG",{src:!0,alt:!0}),rm.forEach(o),is=l(t),Ee=a(t,"P",{});var Ws=i(Ee);ta=a(Ws,"STRONG",{});var lm=i(ta);bl=c(lm,"Note"),lm.forEach(o),wl=c(Ws,": To see how to run all other ControlNet checkpoints, please have a look at "),qo=a(Ws,"A",{href:!0});var pm=i(qo);yl=c(pm,"ControlNet with Stable Diffusion 1.5"),pm.forEach(o),Ws.forEach(o),ss=l(t),ne=a(t,"H2",{class:!0});var Vs=i(ne);$e=a(Vs,"A",{id:!0,class:!0,href:!0});var cm=i($e);oa=a(cm,"SPAN",{});var fm=i(oa);u($t.$$.fragment,fm),fm.forEach(o),cm.forEach(o),El=l(Vs),na=a(Vs,"SPAN",{});var dm=i(na);$l=c(dm,"Combining multiple conditionings"),dm.forEach(o),Vs.forEach(o),rs=l(t),ke=a(t,"P",{});var Bs=i(ke);kl=c(Bs,"Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),aa=a(Bs,"CODE",{});var mm=i(aa);Cl=c(mm,"__call__"),mm.forEach(o),Pl=c(Bs,"."),Bs.forEach(o),ls=l(t),Oo=a(t,"P",{});var hm=i(Oo);Nl=c(hm,"When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),hm.forEach(o),ps=l(t),Ce=a(t,"P",{});var Ks=i(Ce);Dl=c(Ks,"It can also be helpful to vary the "),ia=a(Ks,"CODE",{});var um=i(ia);xl=c(um,"controlnet_conditioning_scales"),um.forEach(o),Tl=c(Ks," to emphasize one conditioning over the other."),Ks.forEach(o),cs=l(t),ae=a(t,"H3",{class:!0});var Ys=i(ae);Pe=a(Ys,"A",{id:!0,class:!0,href:!0});var gm=i(Pe);sa=a(gm,"SPAN",{});var _m=i(sa);u(kt.$$.fragment,_m),_m.forEach(o),gm.forEach(o),Sl=l(Ys),ra=a(Ys,"SPAN",{});var vm=i(ra);jl=c(vm,"Canny conditioning"),vm.forEach(o),Ys.forEach(o),fs=l(t),Go=a(t,"P",{});var bm=i(Go);Al=c(bm,"The original image:"),bm.forEach(o),ds=l(t),Uo=a(t,"IMG",{src:!0}),ms=l(t),zo=a(t,"P",{});var wm=i(zo);Il=c(wm,"Prepare the conditioning:"),wm.forEach(o),hs=l(t),u(Ct.$$.fragment,t),us=l(t),Fo=a(t,"IMG",{src:!0}),gs=l(t),ie=a(t,"H3",{class:!0});var Zs=i(ie);Ne=a(Zs,"A",{id:!0,class:!0,href:!0});var ym=i(Ne);la=a(ym,"SPAN",{});var Em=i(la);u(Pt.$$.fragment,Em),Em.forEach(o),ym.forEach(o),Ml=l(Zs),pa=a(Zs,"SPAN",{});var $m=i(pa);Ll=c($m,"Openpose conditioning"),$m.forEach(o),Zs.forEach(o),_s=l(t),Ro=a(t,"P",{});var km=i(Ro);ql=c(km,"The original image:"),km.forEach(o),vs=l(t),Nt=a(t,"IMG",{src:!0,width:!0}),bs=l(t),Ho=a(t,"P",{});var Cm=i(Ho);Ol=c(Cm,"Prepare the conditioning:"),Cm.forEach(o),ws=l(t),u(Dt.$$.fragment,t),ys=l(t),xt=a(t,"IMG",{src:!0,width:!0}),Es=l(t),se=a(t,"H3",{class:!0});var Js=i(se);De=a(Js,"A",{id:!0,class:!0,href:!0});var Pm=i(De);ca=a(Pm,"SPAN",{});var Nm=i(ca);u(Tt.$$.fragment,Nm),Nm.forEach(o),Pm.forEach(o),Gl=l(Js),fa=a(Js,"SPAN",{});var Dm=i(fa);Ul=c(Dm,"Running ControlNet with multiple conditionings"),Dm.forEach(o),Js.forEach(o),$s=l(t),u(St.$$.fragment,t),ks=l(t),jt=a(t,"IMG",{src:!0,width:!0}),Cs=l(t),re=a(t,"H2",{class:!0});var Qs=i(re);xe=a(Qs,"A",{id:!0,class:!0,href:!0});var xm=i(xe);da=a(xm,"SPAN",{});var Tm=i(da);u(At.$$.fragment,Tm),Tm.forEach(o),xm.forEach(o),zl=l(Qs),ma=a(Qs,"SPAN",{});var Sm=i(ma);Fl=c(Sm,"Available checkpoints"),Sm.forEach(o),Qs.forEach(o),Ps=l(t),W=a(t,"P",{});var Nn=i(W);Rl=c(Nn,"ControlNet requires a "),ha=a(Nn,"EM",{});var jm=i(ha);Hl=c(jm,"control image"),jm.forEach(o),Wl=c(Nn," in addition to the text-to-image "),ua=a(Nn,"EM",{});var Am=i(ua);Vl=c(Am,"prompt"),Am.forEach(o),Bl=c(Nn,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Nn.forEach(o),Ns=l(t),Te=a(t,"P",{});var Xs=i(Te);Kl=c(Xs,"All checkpoints can be found under the authors\u2019 namespace "),It=a(Xs,"A",{href:!0,rel:!0});var Im=i(It);Yl=c(Im,"lllyasviel"),Im.forEach(o),Zl=c(Xs,"."),Xs.forEach(o),Ds=l(t),le=a(t,"H3",{class:!0});var er=i(le);Se=a(er,"A",{id:!0,class:!0,href:!0});var Mm=i(Se);ga=a(Mm,"SPAN",{});var Lm=i(ga);u(Mt.$$.fragment,Lm),Lm.forEach(o),Mm.forEach(o),Jl=l(er),_a=a(er,"SPAN",{});var qm=i(_a);Ql=c(qm,"ControlNet with Stable Diffusion 1.5"),qm.forEach(o),er.forEach(o),xs=l(t),je=a(t,"TABLE",{});var tr=i(je);va=a(tr,"THEAD",{});var Om=i(va);I=a(Om,"TR",{});var Ye=i(I);ba=a(Ye,"TH",{});var Gm=i(ba);Xl=c(Gm,"Model Name"),Gm.forEach(o),ep=l(Ye),wa=a(Ye,"TH",{});var Um=i(wa);tp=c(Um,"Control Image Overview"),Um.forEach(o),op=l(Ye),ya=a(Ye,"TH",{});var zm=i(ya);np=c(zm,"Control Image Example"),zm.forEach(o),ap=l(Ye),Ea=a(Ye,"TH",{});var Fm=i(Ea);ip=c(Fm,"Generated Image Example"),Fm.forEach(o),Ye.forEach(o),Om.forEach(o),sp=l(tr),P=a(tr,"TBODY",{});var D=i(P);M=a(D,"TR",{});var Ze=i(M);Ae=a(Ze,"TD",{});var bi=i(Ae);Lt=a(bi,"A",{href:!0,rel:!0});var Rm=i(Lt);rp=c(Rm,"lllyasviel/sd-controlnet-canny"),Rm.forEach(o),lp=a(bi,"BR",{}),pp=l(bi),$a=a(bi,"EM",{});var Hm=i($a);cp=c(Hm,"Trained with canny edge detection"),Hm.forEach(o),bi.forEach(o),fp=l(Ze),ka=a(Ze,"TD",{});var Wm=i(ka);dp=c(Wm,"A monochrome image with white edges on a black background."),Wm.forEach(o),mp=l(Ze),Ca=a(Ze,"TD",{});var Vm=i(Ca);Wo=a(Vm,"A",{href:!0});var Bm=i(Wo);Ie=a(Bm,"IMG",{width:!0,style:!0,src:!0}),Bm.forEach(o),Vm.forEach(o),hp=l(Ze),Pa=a(Ze,"TD",{});var Km=i(Pa);Vo=a(Km,"A",{href:!0});var Ym=i(Vo);Bo=a(Ym,"IMG",{width:!0,src:!0}),Ym.forEach(o),Km.forEach(o),Ze.forEach(o),up=l(D),L=a(D,"TR",{});var Je=i(L);Me=a(Je,"TD",{});var wi=i(Me);qt=a(wi,"A",{href:!0,rel:!0});var Zm=i(qt);gp=c(Zm,"lllyasviel/sd-controlnet-depth"),Zm.forEach(o),_p=a(wi,"BR",{}),vp=l(wi),Na=a(wi,"EM",{});var Jm=i(Na);bp=c(Jm,"Trained with Midas depth estimation"),Jm.forEach(o),wi.forEach(o),wp=l(Je),Da=a(Je,"TD",{});var Qm=i(Da);yp=c(Qm,"A grayscale image with black representing deep areas and white representing shallow areas."),Qm.forEach(o),Ep=l(Je),xa=a(Je,"TD",{});var Xm=i(xa);Ko=a(Xm,"A",{href:!0});var eh=i(Ko);Yo=a(eh,"IMG",{width:!0,src:!0}),eh.forEach(o),Xm.forEach(o),$p=l(Je),Ta=a(Je,"TD",{});var th=i(Ta);Zo=a(th,"A",{href:!0});var oh=i(Zo);Jo=a(oh,"IMG",{width:!0,src:!0}),oh.forEach(o),th.forEach(o),Je.forEach(o),kp=l(D),q=a(D,"TR",{});var Qe=i(q);Le=a(Qe,"TD",{});var yi=i(Le);Ot=a(yi,"A",{href:!0,rel:!0});var nh=i(Ot);Cp=c(nh,"lllyasviel/sd-controlnet-hed"),nh.forEach(o),Pp=a(yi,"BR",{}),Np=l(yi),Sa=a(yi,"EM",{});var ah=i(Sa);Dp=c(ah,"Trained with HED edge detection (soft edge)"),ah.forEach(o),yi.forEach(o),xp=l(Qe),ja=a(Qe,"TD",{});var ih=i(ja);Tp=c(ih,"A monochrome image with white soft edges on a black background."),ih.forEach(o),Sp=l(Qe),Aa=a(Qe,"TD",{});var sh=i(Aa);Qo=a(sh,"A",{href:!0});var rh=i(Qo);Xo=a(rh,"IMG",{width:!0,src:!0}),rh.forEach(o),sh.forEach(o),jp=l(Qe),Ia=a(Qe,"TD",{});var lh=i(Ia);en=a(lh,"A",{href:!0});var ph=i(en);tn=a(ph,"IMG",{width:!0,src:!0}),ph.forEach(o),lh.forEach(o),Qe.forEach(o),Ap=l(D),O=a(D,"TR",{});var Xe=i(O);qe=a(Xe,"TD",{});var Ei=i(qe);Gt=a(Ei,"A",{href:!0,rel:!0});var ch=i(Gt);Ip=c(ch,"lllyasviel/sd-controlnet-mlsd"),ch.forEach(o),Mp=a(Ei,"BR",{}),Lp=l(Ei),Ma=a(Ei,"EM",{});var fh=i(Ma);qp=c(fh,"Trained with M-LSD line detection"),fh.forEach(o),Ei.forEach(o),Op=l(Xe),La=a(Xe,"TD",{});var dh=i(La);Gp=c(dh,"A monochrome image composed only of white straight lines on a black background."),dh.forEach(o),Up=l(Xe),qa=a(Xe,"TD",{});var mh=i(qa);on=a(mh,"A",{href:!0});var hh=i(on);nn=a(hh,"IMG",{width:!0,src:!0}),hh.forEach(o),mh.forEach(o),zp=l(Xe),Oa=a(Xe,"TD",{});var uh=i(Oa);an=a(uh,"A",{href:!0});var gh=i(an);sn=a(gh,"IMG",{width:!0,src:!0}),gh.forEach(o),uh.forEach(o),Xe.forEach(o),Fp=l(D),G=a(D,"TR",{});var et=i(G);Oe=a(et,"TD",{});var $i=i(Oe);Ut=a($i,"A",{href:!0,rel:!0});var _h=i(Ut);Rp=c(_h,"lllyasviel/sd-controlnet-normal"),_h.forEach(o),Hp=a($i,"BR",{}),Wp=l($i),Ga=a($i,"EM",{});var vh=i(Ga);Vp=c(vh,"Trained with normal map"),vh.forEach(o),$i.forEach(o),Bp=l(et),zt=a(et,"TD",{});var or=i(zt);Kp=c(or,"A "),Ft=a(or,"A",{href:!0,rel:!0});var bh=i(Ft);Yp=c(bh,"normal mapped"),bh.forEach(o),Zp=c(or," image."),or.forEach(o),Jp=l(et),Ua=a(et,"TD",{});var wh=i(Ua);rn=a(wh,"A",{href:!0});var yh=i(rn);ln=a(yh,"IMG",{width:!0,src:!0}),yh.forEach(o),wh.forEach(o),Qp=l(et),za=a(et,"TD",{});var Eh=i(za);pn=a(Eh,"A",{href:!0});var $h=i(pn);cn=a($h,"IMG",{width:!0,src:!0}),$h.forEach(o),Eh.forEach(o),et.forEach(o),Xp=l(D),U=a(D,"TR",{});var tt=i(U);Ge=a(tt,"TD",{});var ki=i(Ge);Rt=a(ki,"A",{href:!0,rel:!0});var kh=i(Rt);ec=c(kh,"lllyasviel/sd-controlnet-openpose"),kh.forEach(o),tc=a(ki,"BR",{}),oc=l(ki),Fa=a(ki,"EM",{});var Ch=i(Fa);nc=c(Ch,"Trained with OpenPose bone image"),Ch.forEach(o),ki.forEach(o),ac=l(tt),Ht=a(tt,"TD",{});var nr=i(Ht);ic=c(nr,"A "),Wt=a(nr,"A",{href:!0,rel:!0});var Ph=i(Wt);sc=c(Ph,"OpenPose bone"),Ph.forEach(o),rc=c(nr," image."),nr.forEach(o),lc=l(tt),Ra=a(tt,"TD",{});var Nh=i(Ra);fn=a(Nh,"A",{href:!0});var Dh=i(fn);dn=a(Dh,"IMG",{width:!0,src:!0}),Dh.forEach(o),Nh.forEach(o),pc=l(tt),Ha=a(tt,"TD",{});var xh=i(Ha);mn=a(xh,"A",{href:!0});var Th=i(mn);hn=a(Th,"IMG",{width:!0,src:!0}),Th.forEach(o),xh.forEach(o),tt.forEach(o),cc=l(D),z=a(D,"TR",{});var ot=i(z);Ue=a(ot,"TD",{});var Ci=i(Ue);Vt=a(Ci,"A",{href:!0,rel:!0});var Sh=i(Vt);fc=c(Sh,"lllyasviel/sd-controlnet-scribble"),Sh.forEach(o),dc=a(Ci,"BR",{}),mc=l(Ci),Wa=a(Ci,"EM",{});var jh=i(Wa);hc=c(jh,"Trained with human scribbles"),jh.forEach(o),Ci.forEach(o),uc=l(ot),Va=a(ot,"TD",{});var Ah=i(Va);gc=c(Ah,"A hand-drawn monochrome image with white outlines on a black background."),Ah.forEach(o),_c=l(ot),Ba=a(ot,"TD",{});var Ih=i(Ba);un=a(Ih,"A",{href:!0});var Mh=i(un);gn=a(Mh,"IMG",{width:!0,src:!0}),Mh.forEach(o),Ih.forEach(o),vc=l(ot),Ka=a(ot,"TD",{});var Lh=i(Ka);_n=a(Lh,"A",{href:!0});var qh=i(_n);vn=a(qh,"IMG",{width:!0,src:!0}),qh.forEach(o),Lh.forEach(o),ot.forEach(o),bc=l(D),F=a(D,"TR",{});var nt=i(F);Bt=a(nt,"TD",{});var ar=i(Bt);Kt=a(ar,"A",{href:!0,rel:!0});var Oh=i(Kt);wc=c(Oh,"lllyasviel/sd-controlnet-seg"),Oh.forEach(o),yc=a(ar,"BR",{}),Ya=a(ar,"EM",{});var Gh=i(Ya);Ec=c(Gh,"Trained with semantic segmentation"),Gh.forEach(o),ar.forEach(o),$c=l(nt),Yt=a(nt,"TD",{});var ir=i(Yt);kc=c(ir,"An "),Zt=a(ir,"A",{href:!0,rel:!0});var Uh=i(Zt);Cc=c(Uh,"ADE20K"),Uh.forEach(o),Pc=c(ir,"\u2019s segmentation protocol image."),ir.forEach(o),Nc=l(nt),Za=a(nt,"TD",{});var zh=i(Za);bn=a(zh,"A",{href:!0});var Fh=i(bn);wn=a(Fh,"IMG",{width:!0,src:!0}),Fh.forEach(o),zh.forEach(o),Dc=l(nt),Ja=a(nt,"TD",{});var Rh=i(Ja);yn=a(Rh,"A",{href:!0});var Hh=i(yn);En=a(Hh,"IMG",{width:!0,src:!0}),Hh.forEach(o),Rh.forEach(o),nt.forEach(o),D.forEach(o),tr.forEach(o),Ts=l(t),pe=a(t,"H2",{class:!0});var sr=i(pe);ze=a(sr,"A",{id:!0,class:!0,href:!0});var Wh=i(ze);Qa=a(Wh,"SPAN",{});var Vh=i(Qa);u(Jt.$$.fragment,Vh),Vh.forEach(o),Wh.forEach(o),xc=l(sr),Xa=a(sr,"SPAN",{});var Bh=i(Xa);Tc=c(Bh,"StableDiffusionControlNetPipeline"),Bh.forEach(o),sr.forEach(o),Ss=l(t),w=a(t,"DIV",{class:!0});var E=i(w);u(Qt.$$.fragment,E),Sc=l(E),ei=a(E,"P",{});var Kh=i(ei);jc=c(Kh,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Kh.forEach(o),Ac=l(E),Xt=a(E,"P",{});var rr=i(Xt);Ic=c(rr,"This model inherits from "),$n=a(rr,"A",{href:!0});var Yh=i($n);Mc=c(Yh,"DiffusionPipeline"),Yh.forEach(o),Lc=c(rr,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),rr.forEach(o),qc=l(E),V=a(E,"DIV",{class:!0});var Dn=i(V);u(eo.$$.fragment,Dn),Oc=l(Dn),ti=a(Dn,"P",{});var Zh=i(ti);Gc=c(Zh,"Function invoked when calling the pipeline for generation."),Zh.forEach(o),Uc=l(Dn),u(Fe.$$.fragment,Dn),Dn.forEach(o),zc=l(E),B=a(E,"DIV",{class:!0});var xn=i(B);u(to.$$.fragment,xn),Fc=l(xn),oi=a(xn,"P",{});var Jh=i(oi);Rc=c(Jh,"Enable sliced attention computation."),Jh.forEach(o),Hc=l(xn),ni=a(xn,"P",{});var Qh=i(ni);Wc=c(Qh,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Qh.forEach(o),xn.forEach(o),Vc=l(E),Re=a(E,"DIV",{class:!0});var lr=i(Re);u(oo.$$.fragment,lr),Bc=l(lr),no=a(lr,"P",{});var pr=i(no);Kc=c(pr,"Disable sliced attention computation. If "),ai=a(pr,"CODE",{});var Xh=i(ai);Yc=c(Xh,"enable_attention_slicing"),Xh.forEach(o),Zc=c(pr,` was previously invoked, this method will go
back to computing attention in one step.`),pr.forEach(o),lr.forEach(o),Jc=l(E),K=a(E,"DIV",{class:!0});var Tn=i(K);u(ao.$$.fragment,Tn),Qc=l(Tn),ii=a(Tn,"P",{});var eu=i(ii);Xc=c(eu,"Enable sliced VAE decoding."),eu.forEach(o),ef=l(Tn),si=a(Tn,"P",{});var tu=i(si);tf=c(tu,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),tu.forEach(o),Tn.forEach(o),of=l(E),He=a(E,"DIV",{class:!0});var cr=i(He);u(io.$$.fragment,cr),nf=l(cr),so=a(cr,"P",{});var fr=i(so);af=c(fr,"Disable sliced VAE decoding. If "),ri=a(fr,"CODE",{});var ou=i(ri);sf=c(ou,"enable_vae_slicing"),ou.forEach(o),rf=c(fr,` was previously invoked, this method will go back to
computing decoding in one step.`),fr.forEach(o),cr.forEach(o),lf=l(E),T=a(E,"DIV",{class:!0});var Y=i(T);u(ro.$$.fragment,Y),pf=l(Y),li=a(Y,"P",{});var nu=i(li);cf=c(nu,"Enable memory efficient attention as implemented in xformers."),nu.forEach(o),ff=l(Y),pi=a(Y,"P",{});var au=i(pi);df=c(au,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),au.forEach(o),mf=l(Y),ci=a(Y,"P",{});var iu=i(ci);hf=c(iu,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),iu.forEach(o),uf=l(Y),u(We.$$.fragment,Y),Y.forEach(o),gf=l(E),Ve=a(E,"DIV",{class:!0});var dr=i(Ve);u(lo.$$.fragment,dr),_f=l(dr),fi=a(dr,"P",{});var su=i(fi);vf=c(su,"Disable memory efficient attention as implemented in xformers."),su.forEach(o),dr.forEach(o),bf=l(E),Be=a(E,"DIV",{class:!0});var mr=i(Be);u(po.$$.fragment,mr),wf=l(mr),S=a(mr,"P",{});var Z=i(S);yf=c(Z,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),di=a(Z,"CODE",{});var ru=i(di);Ef=c(ru,"enable_sequential_cpu_offload"),ru.forEach(o),$f=c(Z,", this method moves one whole model at a time to the GPU when its "),mi=a(Z,"CODE",{});var lu=i(mi);kf=c(lu,"forward"),lu.forEach(o),Cf=c(Z,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),hi=a(Z,"CODE",{});var pu=i(hi);Pf=c(pu,"enable_sequential_cpu_offload"),pu.forEach(o),Nf=c(Z,", but performance is much better due to the iterative execution of the "),ui=a(Z,"CODE",{});var cu=i(ui);Df=c(cu,"unet"),cu.forEach(o),xf=c(Z,"."),Z.forEach(o),mr.forEach(o),Tf=l(E),Ke=a(E,"DIV",{class:!0});var hr=i(Ke);u(co.$$.fragment,hr),Sf=l(hr),ce=a(hr,"P",{});var Sn=i(ce);jf=c(Sn,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),gi=a(Sn,"CODE",{});var fu=i(gi);Af=c(fu,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),fu.forEach(o),If=c(Sn,"forward"),_i=a(Sn,"CODE",{});var du=i(_i);Mf=c(du,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),du.forEach(o),Lf=c(Sn,"enable_model_cpu_offload`, but performance is lower."),Sn.forEach(o),hr.forEach(o),E.forEach(o),this.h()},h(){s(k,"name","hf:doc:metadata"),s(k,"content",JSON.stringify(ku)),s(y,"id","texttoimage-generation-with-controlnet-conditioning"),s(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(y,"href","#texttoimage-generation-with-controlnet-conditioning"),s(C,"class","relative group"),s(fe,"id","overview"),s(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(fe,"href","#overview"),s(Q,"class","relative group"),s(st,"href","https://arxiv.org/abs/2302.05543"),s(st,"rel","nofollow"),s(rt,"href","https://huggingface.co/takuma104"),s(rt,"rel","nofollow"),s(lt,"href","https://arxiv.org/abs/2302.05543"),s(lt,"rel","nofollow"),s(pt,"href","https://github.com/lllyasviel/ControlNet"),s(pt,"rel","nofollow"),s(he,"id","available-pipelines"),s(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(he,"href","#available-pipelines"),s(X,"class","relative group"),s(vo,"align","center"),s(ft,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),s(ft,"rel","nofollow"),s(dt,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),s(dt,"rel","nofollow"),s(bo,"align","center"),s(ge,"id","usage-example"),s(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(ge,"href","#usage-example"),s(oe,"class","relative group"),s(yo,"href","/docs/diffusers/pr_2759/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),s(wo,"start","2"),s(ut,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),s(ut,"rel","nofollow"),$($o.src,Of="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||s($o,"src",Of),s($o,"alt","img"),s(ko,"href","#controlnet-with-stable-diffusion-1.5"),$(To.src,Gf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||s(To,"src",Gf),s(To,"alt","img"),s(So,"href","runwayml/stable-diffusion-v1-5"),s(jo,"href","/docs/diffusers/pr_2759/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),$(Lo.src,Uf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||s(Lo,"src",Uf),s(Lo,"alt","img"),s(qo,"href","#controlnet-with-stable-diffusion-1.5"),s($e,"id","combining-multiple-conditionings"),s($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s($e,"href","#combining-multiple-conditionings"),s(ne,"class","relative group"),s(Pe,"id","canny-conditioning"),s(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(Pe,"href","#canny-conditioning"),s(ae,"class","relative group"),$(Uo.src,zf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png")||s(Uo,"src",zf),$(Fo.src,Ff="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/landscape_canny_masked.png")||s(Fo,"src",Ff),s(Ne,"id","openpose-conditioning"),s(Ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(Ne,"href","#openpose-conditioning"),s(ie,"class","relative group"),$(Nt.src,Rf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png")||s(Nt,"src",Rf),s(Nt,"width","600"),$(xt.src,Hf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/person_pose.png")||s(xt,"src",Hf),s(xt,"width","600"),s(De,"id","running-controlnet-with-multiple-conditionings"),s(De,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(De,"href","#running-controlnet-with-multiple-conditionings"),s(se,"class","relative group"),$(jt.src,Wf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/multi_controlnet_output.png")||s(jt,"src",Wf),s(jt,"width","600"),s(xe,"id","available-checkpoints"),s(xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(xe,"href","#available-checkpoints"),s(re,"class","relative group"),s(It,"href","https://huggingface.co/lllyasviel"),s(It,"rel","nofollow"),s(Se,"id","controlnet-with-stable-diffusion-15"),s(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(Se,"href","#controlnet-with-stable-diffusion-15"),s(le,"class","relative group"),s(Lt,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),s(Lt,"rel","nofollow"),s(Ie,"width","64"),mu(Ie,"margin","0"),mu(Ie,"padding","0"),$(Ie.src,Vf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||s(Ie,"src",Vf),s(Wo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),s(Bo,"width","64"),$(Bo.src,Bf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||s(Bo,"src",Bf),s(Vo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),s(qt,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),s(qt,"rel","nofollow"),s(Yo,"width","64"),$(Yo.src,Kf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||s(Yo,"src",Kf),s(Ko,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),s(Jo,"width","64"),$(Jo.src,Yf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||s(Jo,"src",Yf),s(Zo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),s(Ot,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),s(Ot,"rel","nofollow"),s(Xo,"width","64"),$(Xo.src,Zf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||s(Xo,"src",Zf),s(Qo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),s(tn,"width","64"),$(tn.src,Jf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||s(tn,"src",Jf),s(en,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),s(Gt,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),s(Gt,"rel","nofollow"),s(nn,"width","64"),$(nn.src,Qf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||s(nn,"src",Qf),s(on,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),s(sn,"width","64"),$(sn.src,Xf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||s(sn,"src",Xf),s(an,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),s(Ut,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),s(Ut,"rel","nofollow"),s(Ft,"href","https://en.wikipedia.org/wiki/Normal_mapping"),s(Ft,"rel","nofollow"),s(ln,"width","64"),$(ln.src,ed="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||s(ln,"src",ed),s(rn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),s(cn,"width","64"),$(cn.src,td="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||s(cn,"src",td),s(pn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),s(Rt,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),s(Rt,"rel","nofollow"),s(Wt,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),s(Wt,"rel","nofollow"),s(dn,"width","64"),$(dn.src,od="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||s(dn,"src",od),s(fn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),s(hn,"width","64"),$(hn.src,nd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||s(hn,"src",nd),s(mn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),s(Vt,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),s(Vt,"rel","nofollow"),s(gn,"width","64"),$(gn.src,ad="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||s(gn,"src",ad),s(un,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),s(vn,"width","64"),$(vn.src,id="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||s(vn,"src",id),s(_n,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),s(Kt,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),s(Kt,"rel","nofollow"),s(Zt,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),s(Zt,"rel","nofollow"),s(wn,"width","64"),$(wn.src,sd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||s(wn,"src",sd),s(bn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),s(En,"width","64"),$(En.src,rd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||s(En,"src",rd),s(yn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),s(ze,"id","diffusers.StableDiffusionControlNetPipeline"),s(ze,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(ze,"href","#diffusers.StableDiffusionControlNetPipeline"),s(pe,"class","relative group"),s($n,"href","/docs/diffusers/pr_2759/en/api/pipelines/text_to_video#diffusers.DiffusionPipeline"),s(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(He,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,f){e(document.head,k),d(t,j,f),d(t,C,f),e(C,y),e(y,x),g(m,x,null),e(C,N),e(C,jn),e(jn,ur),d(t,Pi,f),d(t,Q,f),e(Q,fe),e(fe,An),g(at,An,null),e(Q,gr),e(Q,In),e(In,_r),d(t,Ni,f),d(t,it,f),e(it,st),e(st,vr),e(it,br),d(t,Di,f),d(t,ho,f),e(ho,wr),d(t,xi,f),d(t,uo,f),e(uo,yr),d(t,Ti,f),d(t,go,f),e(go,Mn),e(Mn,Er),d(t,Si,f),d(t,de,f),e(de,$r),e(de,rt),e(rt,kr),e(de,Cr),d(t,ji,f),d(t,_o,f),e(_o,Pr),d(t,Ai,f),d(t,me,f),e(me,Ln),e(Ln,lt),e(lt,Nr),e(me,Dr),e(me,qn),e(qn,pt),e(pt,xr),d(t,Ii,f),d(t,X,f),e(X,he),e(he,On),g(ct,On,null),e(X,Tr),e(X,Gn),e(Gn,Sr),d(t,Mi,f),d(t,ue,f),e(ue,Un),e(Un,ee),e(ee,zn),e(zn,jr),e(ee,Ar),e(ee,Fn),e(Fn,Ir),e(ee,Mr),e(ee,vo),e(vo,Lr),e(ue,qr),e(ue,Rn),e(Rn,te),e(te,Hn),e(Hn,ft),e(ft,Or),e(te,Gr),e(te,Wn),e(Wn,Vn),e(Vn,Ur),e(te,zr),e(te,bo),e(bo,dt),e(dt,Fr),d(t,Li,f),d(t,oe,f),e(oe,ge),e(ge,Bn),g(mt,Bn,null),e(oe,Rr),e(oe,Kn),e(Kn,Hr),d(t,qi,f),d(t,_e,f),e(_e,Wr),e(_e,Yn),e(Yn,Vr),e(_e,Br),d(t,Oi,f),d(t,ve,f),e(ve,Zn),e(Zn,Jn),e(Jn,Qn),e(Qn,Kr),e(ve,Yr),e(ve,Xn),e(Xn,wo),e(wo,ht),e(ht,Zr),e(ht,yo),e(yo,Jr),e(ht,Qr),d(t,Gi,f),d(t,be,f),e(be,Xr),e(be,ut),e(ut,el),e(be,tl),d(t,Ui,f),g(gt,t,f),d(t,zi,f),d(t,Eo,f),e(Eo,$o),d(t,Fi,f),d(t,H,f),e(H,ol),e(H,ea),e(ea,nl),e(H,al),e(H,ko),e(ko,il),e(H,sl),d(t,Ri,f),d(t,Co,f),e(Co,rl),d(t,Hi,f),g(_t,t,f),d(t,Wi,f),d(t,Po,f),e(Po,ll),d(t,Vi,f),g(vt,t,f),d(t,Bi,f),d(t,No,f),e(No,pl),d(t,Ki,f),g(bt,t,f),d(t,Yi,f),d(t,Do,f),e(Do,cl),d(t,Zi,f),d(t,xo,f),e(xo,To),d(t,Ji,f),d(t,we,f),e(we,fl),e(we,So),e(So,dl),e(we,ml),d(t,Qi,f),g(wt,t,f),d(t,Xi,f),d(t,ye,f),e(ye,hl),e(ye,jo),e(jo,ul),e(ye,gl),d(t,es,f),g(yt,t,f),d(t,ts,f),d(t,Ao,f),e(Ao,_l),d(t,os,f),g(Et,t,f),d(t,ns,f),d(t,Io,f),e(Io,vl),d(t,as,f),d(t,Mo,f),e(Mo,Lo),d(t,is,f),d(t,Ee,f),e(Ee,ta),e(ta,bl),e(Ee,wl),e(Ee,qo),e(qo,yl),d(t,ss,f),d(t,ne,f),e(ne,$e),e($e,oa),g($t,oa,null),e(ne,El),e(ne,na),e(na,$l),d(t,rs,f),d(t,ke,f),e(ke,kl),e(ke,aa),e(aa,Cl),e(ke,Pl),d(t,ls,f),d(t,Oo,f),e(Oo,Nl),d(t,ps,f),d(t,Ce,f),e(Ce,Dl),e(Ce,ia),e(ia,xl),e(Ce,Tl),d(t,cs,f),d(t,ae,f),e(ae,Pe),e(Pe,sa),g(kt,sa,null),e(ae,Sl),e(ae,ra),e(ra,jl),d(t,fs,f),d(t,Go,f),e(Go,Al),d(t,ds,f),d(t,Uo,f),d(t,ms,f),d(t,zo,f),e(zo,Il),d(t,hs,f),g(Ct,t,f),d(t,us,f),d(t,Fo,f),d(t,gs,f),d(t,ie,f),e(ie,Ne),e(Ne,la),g(Pt,la,null),e(ie,Ml),e(ie,pa),e(pa,Ll),d(t,_s,f),d(t,Ro,f),e(Ro,ql),d(t,vs,f),d(t,Nt,f),d(t,bs,f),d(t,Ho,f),e(Ho,Ol),d(t,ws,f),g(Dt,t,f),d(t,ys,f),d(t,xt,f),d(t,Es,f),d(t,se,f),e(se,De),e(De,ca),g(Tt,ca,null),e(se,Gl),e(se,fa),e(fa,Ul),d(t,$s,f),g(St,t,f),d(t,ks,f),d(t,jt,f),d(t,Cs,f),d(t,re,f),e(re,xe),e(xe,da),g(At,da,null),e(re,zl),e(re,ma),e(ma,Fl),d(t,Ps,f),d(t,W,f),e(W,Rl),e(W,ha),e(ha,Hl),e(W,Wl),e(W,ua),e(ua,Vl),e(W,Bl),d(t,Ns,f),d(t,Te,f),e(Te,Kl),e(Te,It),e(It,Yl),e(Te,Zl),d(t,Ds,f),d(t,le,f),e(le,Se),e(Se,ga),g(Mt,ga,null),e(le,Jl),e(le,_a),e(_a,Ql),d(t,xs,f),d(t,je,f),e(je,va),e(va,I),e(I,ba),e(ba,Xl),e(I,ep),e(I,wa),e(wa,tp),e(I,op),e(I,ya),e(ya,np),e(I,ap),e(I,Ea),e(Ea,ip),e(je,sp),e(je,P),e(P,M),e(M,Ae),e(Ae,Lt),e(Lt,rp),e(Ae,lp),e(Ae,pp),e(Ae,$a),e($a,cp),e(M,fp),e(M,ka),e(ka,dp),e(M,mp),e(M,Ca),e(Ca,Wo),e(Wo,Ie),e(M,hp),e(M,Pa),e(Pa,Vo),e(Vo,Bo),e(P,up),e(P,L),e(L,Me),e(Me,qt),e(qt,gp),e(Me,_p),e(Me,vp),e(Me,Na),e(Na,bp),e(L,wp),e(L,Da),e(Da,yp),e(L,Ep),e(L,xa),e(xa,Ko),e(Ko,Yo),e(L,$p),e(L,Ta),e(Ta,Zo),e(Zo,Jo),e(P,kp),e(P,q),e(q,Le),e(Le,Ot),e(Ot,Cp),e(Le,Pp),e(Le,Np),e(Le,Sa),e(Sa,Dp),e(q,xp),e(q,ja),e(ja,Tp),e(q,Sp),e(q,Aa),e(Aa,Qo),e(Qo,Xo),e(q,jp),e(q,Ia),e(Ia,en),e(en,tn),e(P,Ap),e(P,O),e(O,qe),e(qe,Gt),e(Gt,Ip),e(qe,Mp),e(qe,Lp),e(qe,Ma),e(Ma,qp),e(O,Op),e(O,La),e(La,Gp),e(O,Up),e(O,qa),e(qa,on),e(on,nn),e(O,zp),e(O,Oa),e(Oa,an),e(an,sn),e(P,Fp),e(P,G),e(G,Oe),e(Oe,Ut),e(Ut,Rp),e(Oe,Hp),e(Oe,Wp),e(Oe,Ga),e(Ga,Vp),e(G,Bp),e(G,zt),e(zt,Kp),e(zt,Ft),e(Ft,Yp),e(zt,Zp),e(G,Jp),e(G,Ua),e(Ua,rn),e(rn,ln),e(G,Qp),e(G,za),e(za,pn),e(pn,cn),e(P,Xp),e(P,U),e(U,Ge),e(Ge,Rt),e(Rt,ec),e(Ge,tc),e(Ge,oc),e(Ge,Fa),e(Fa,nc),e(U,ac),e(U,Ht),e(Ht,ic),e(Ht,Wt),e(Wt,sc),e(Ht,rc),e(U,lc),e(U,Ra),e(Ra,fn),e(fn,dn),e(U,pc),e(U,Ha),e(Ha,mn),e(mn,hn),e(P,cc),e(P,z),e(z,Ue),e(Ue,Vt),e(Vt,fc),e(Ue,dc),e(Ue,mc),e(Ue,Wa),e(Wa,hc),e(z,uc),e(z,Va),e(Va,gc),e(z,_c),e(z,Ba),e(Ba,un),e(un,gn),e(z,vc),e(z,Ka),e(Ka,_n),e(_n,vn),e(P,bc),e(P,F),e(F,Bt),e(Bt,Kt),e(Kt,wc),e(Bt,yc),e(Bt,Ya),e(Ya,Ec),e(F,$c),e(F,Yt),e(Yt,kc),e(Yt,Zt),e(Zt,Cc),e(Yt,Pc),e(F,Nc),e(F,Za),e(Za,bn),e(bn,wn),e(F,Dc),e(F,Ja),e(Ja,yn),e(yn,En),d(t,Ts,f),d(t,pe,f),e(pe,ze),e(ze,Qa),g(Jt,Qa,null),e(pe,xc),e(pe,Xa),e(Xa,Tc),d(t,Ss,f),d(t,w,f),g(Qt,w,null),e(w,Sc),e(w,ei),e(ei,jc),e(w,Ac),e(w,Xt),e(Xt,Ic),e(Xt,$n),e($n,Mc),e(Xt,Lc),e(w,qc),e(w,V),g(eo,V,null),e(V,Oc),e(V,ti),e(ti,Gc),e(V,Uc),g(Fe,V,null),e(w,zc),e(w,B),g(to,B,null),e(B,Fc),e(B,oi),e(oi,Rc),e(B,Hc),e(B,ni),e(ni,Wc),e(w,Vc),e(w,Re),g(oo,Re,null),e(Re,Bc),e(Re,no),e(no,Kc),e(no,ai),e(ai,Yc),e(no,Zc),e(w,Jc),e(w,K),g(ao,K,null),e(K,Qc),e(K,ii),e(ii,Xc),e(K,ef),e(K,si),e(si,tf),e(w,of),e(w,He),g(io,He,null),e(He,nf),e(He,so),e(so,af),e(so,ri),e(ri,sf),e(so,rf),e(w,lf),e(w,T),g(ro,T,null),e(T,pf),e(T,li),e(li,cf),e(T,ff),e(T,pi),e(pi,df),e(T,mf),e(T,ci),e(ci,hf),e(T,uf),g(We,T,null),e(w,gf),e(w,Ve),g(lo,Ve,null),e(Ve,_f),e(Ve,fi),e(fi,vf),e(w,bf),e(w,Be),g(po,Be,null),e(Be,wf),e(Be,S),e(S,yf),e(S,di),e(di,Ef),e(S,$f),e(S,mi),e(mi,kf),e(S,Cf),e(S,hi),e(hi,Pf),e(S,Nf),e(S,ui),e(ui,Df),e(S,xf),e(w,Tf),e(w,Ke),g(co,Ke,null),e(Ke,Sf),e(Ke,ce),e(ce,jf),e(ce,gi),e(gi,Af),e(ce,If),e(ce,_i),e(_i,Mf),e(ce,Lf),js=!0},p(t,[f]){const fo={};f&2&&(fo.$$scope={dirty:f,ctx:t}),Fe.$set(fo);const vi={};f&2&&(vi.$$scope={dirty:f,ctx:t}),We.$set(vi)},i(t){js||(_(m.$$.fragment,t),_(at.$$.fragment,t),_(ct.$$.fragment,t),_(mt.$$.fragment,t),_(gt.$$.fragment,t),_(_t.$$.fragment,t),_(vt.$$.fragment,t),_(bt.$$.fragment,t),_(wt.$$.fragment,t),_(yt.$$.fragment,t),_(Et.$$.fragment,t),_($t.$$.fragment,t),_(kt.$$.fragment,t),_(Ct.$$.fragment,t),_(Pt.$$.fragment,t),_(Dt.$$.fragment,t),_(Tt.$$.fragment,t),_(St.$$.fragment,t),_(At.$$.fragment,t),_(Mt.$$.fragment,t),_(Jt.$$.fragment,t),_(Qt.$$.fragment,t),_(eo.$$.fragment,t),_(Fe.$$.fragment,t),_(to.$$.fragment,t),_(oo.$$.fragment,t),_(ao.$$.fragment,t),_(io.$$.fragment,t),_(ro.$$.fragment,t),_(We.$$.fragment,t),_(lo.$$.fragment,t),_(po.$$.fragment,t),_(co.$$.fragment,t),js=!0)},o(t){v(m.$$.fragment,t),v(at.$$.fragment,t),v(ct.$$.fragment,t),v(mt.$$.fragment,t),v(gt.$$.fragment,t),v(_t.$$.fragment,t),v(vt.$$.fragment,t),v(bt.$$.fragment,t),v(wt.$$.fragment,t),v(yt.$$.fragment,t),v(Et.$$.fragment,t),v($t.$$.fragment,t),v(kt.$$.fragment,t),v(Ct.$$.fragment,t),v(Pt.$$.fragment,t),v(Dt.$$.fragment,t),v(Tt.$$.fragment,t),v(St.$$.fragment,t),v(At.$$.fragment,t),v(Mt.$$.fragment,t),v(Jt.$$.fragment,t),v(Qt.$$.fragment,t),v(eo.$$.fragment,t),v(Fe.$$.fragment,t),v(to.$$.fragment,t),v(oo.$$.fragment,t),v(ao.$$.fragment,t),v(io.$$.fragment,t),v(ro.$$.fragment,t),v(We.$$.fragment,t),v(lo.$$.fragment,t),v(po.$$.fragment,t),v(co.$$.fragment,t),js=!1},d(t){o(k),t&&o(j),t&&o(C),b(m),t&&o(Pi),t&&o(Q),b(at),t&&o(Ni),t&&o(it),t&&o(Di),t&&o(ho),t&&o(xi),t&&o(uo),t&&o(Ti),t&&o(go),t&&o(Si),t&&o(de),t&&o(ji),t&&o(_o),t&&o(Ai),t&&o(me),t&&o(Ii),t&&o(X),b(ct),t&&o(Mi),t&&o(ue),t&&o(Li),t&&o(oe),b(mt),t&&o(qi),t&&o(_e),t&&o(Oi),t&&o(ve),t&&o(Gi),t&&o(be),t&&o(Ui),b(gt,t),t&&o(zi),t&&o(Eo),t&&o(Fi),t&&o(H),t&&o(Ri),t&&o(Co),t&&o(Hi),b(_t,t),t&&o(Wi),t&&o(Po),t&&o(Vi),b(vt,t),t&&o(Bi),t&&o(No),t&&o(Ki),b(bt,t),t&&o(Yi),t&&o(Do),t&&o(Zi),t&&o(xo),t&&o(Ji),t&&o(we),t&&o(Qi),b(wt,t),t&&o(Xi),t&&o(ye),t&&o(es),b(yt,t),t&&o(ts),t&&o(Ao),t&&o(os),b(Et,t),t&&o(ns),t&&o(Io),t&&o(as),t&&o(Mo),t&&o(is),t&&o(Ee),t&&o(ss),t&&o(ne),b($t),t&&o(rs),t&&o(ke),t&&o(ls),t&&o(Oo),t&&o(ps),t&&o(Ce),t&&o(cs),t&&o(ae),b(kt),t&&o(fs),t&&o(Go),t&&o(ds),t&&o(Uo),t&&o(ms),t&&o(zo),t&&o(hs),b(Ct,t),t&&o(us),t&&o(Fo),t&&o(gs),t&&o(ie),b(Pt),t&&o(_s),t&&o(Ro),t&&o(vs),t&&o(Nt),t&&o(bs),t&&o(Ho),t&&o(ws),b(Dt,t),t&&o(ys),t&&o(xt),t&&o(Es),t&&o(se),b(Tt),t&&o($s),b(St,t),t&&o(ks),t&&o(jt),t&&o(Cs),t&&o(re),b(At),t&&o(Ps),t&&o(W),t&&o(Ns),t&&o(Te),t&&o(Ds),t&&o(le),b(Mt),t&&o(xs),t&&o(je),t&&o(Ts),t&&o(pe),b(Jt),t&&o(Ss),t&&o(w),b(Qt),b(eo),b(Fe),b(to),b(oo),b(ao),b(io),b(ro),b(We),b(lo),b(po),b(co)}}}const ku={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"combining-multiple-conditionings",sections:[{local:"canny-conditioning",title:"Canny conditioning"},{local:"openpose-conditioning",title:"Openpose conditioning"},{local:"running-controlnet-with-multiple-conditionings",title:"Running ControlNet with multiple conditionings"}],title:"Combining multiple conditionings"},{local:"available-checkpoints",sections:[{local:"controlnet-with-stable-diffusion-15",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"},{local:"diffusers.StableDiffusionControlNetPipeline",title:"StableDiffusionControlNetPipeline"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function Cu(mo){return wu(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Su extends gu{constructor(k){super();_u(this,k,Cu,$u,vu,{})}}export{Su as default,ku as metadata};
